unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    i: TImage;
    RadioGroup1: TRadioGroup;
    rb_koch: TRadioButton;
    rb_sirping: TRadioButton;
    rb_piano: TRadioButton;
    Button1: TButton;
    sb_depth: TScrollBar;
    b_abbruch: TButton;
    l_depth: TLabel;
    b_ende: TButton;
    procedure Button1Click(Sender: TObject);
    procedure b_abbruchClick(Sender: TObject);
    procedure sb_depthChange(Sender: TObject);
    procedure b_endeClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

var
  v_abbruch:boolean=false;
  
{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);

  procedure koch(vp_links,vp_rechts:tpoint;vp_Depth:integer);
  var
    vp_mlinks,vp_mrechts,vp_m:tpoint;
  begin
    if (vp_depth>=sb_depth.Position)or(v_abbruch)
    then // Fertig
      begin
        with i.picture.Bitmap.Canvas
        do
          begin
            moveto(vp_links.x,vp_links.y);
            lineto(vp_rechts.x,vp_rechts.y);
          end;
      end
    else
      begin
        inc(vp_Depth);
        application.processmessages;
        vp_mlinks.x:=vp_links.x+((vp_rechts.x-vp_links.x) div 3);
        vp_mlinks.y:=vp_links.y+((vp_rechts.y-vp_links.y) div 3);
        koch(vp_links,vp_mlinks,vp_depth);

        vp_mrechts.x:=vp_mlinks.x+(vp_rechts.x-vp_mlinks.x) div 2;
        vp_mrechts.y:=vp_mlinks.y+(vp_rechts.y-vp_mlinks.y) div 2;
        koch(vp_mrechts,vp_rechts,vp_depth);

        vp_m.x:=vp_mlinks.x+(vp_mrechts.x-vp_mlinks.x)div 2;
        vp_m.y:=vp_mlinks.y+(vp_mrechts.y-vp_mlinks.y)div 2;

        vp_m.x:=vp_m.x+round((vp_mrechts.y-vp_mlinks.y)*sqrt(3)/2);
        vp_m.y:=vp_m.y-round((vp_mrechts.x-vp_mlinks.x)*sqrt(3)/2);
        koch(vp_mlinks,vp_m,vp_depth);
        koch(vp_m,vp_mrechts,vp_depth);
      end;
  end;

  procedure sirping(vp_links,vp_rechts:tpoint;vp_Depth:integer);
  var
    vp_length,vp_linksx,vp_rechtsx,vp_obeny,vp_unteny: integer;
  begin
    if (vp_depth>=sb_depth.Position)or(v_abbruch)
    then // Fertig
        with i.picture.Bitmap.Canvas
        do
          begin
            moveto(vp_links.x,vp_links.y);
            lineto(vp_rechts.x,vp_rechts.y);
          end
    else
      begin
        inc(vp_Depth);
        application.processmessages;
        vp_length:=((vp_rechts.x-vp_links.x) div 3);
        vp_linksx:=vp_links.x+vp_length;
        vp_rechtsx:=vp_linksx+vp_length;
        vp_obeny:=vp_links.y-vp_length;
        vp_unteny:=vp_links.y+vp_length;
        with i.Picture.Bitmap.Canvas
        do
          begin
            moveto(vp_linksx,vp_obeny);
            lineto(vp_linksx,vp_unteny);
            moveto(vp_rechtsx,vp_obeny);
            lineto(vp_rechtsx,vp_unteny);
          end;
        sirping(vp_links,point(vp_linksx,vp_links.y),vp_depth);
        sirping(point(vp_rechtsx,vp_links.y),vp_rechts,vp_depth);
        sirping(point(vp_linksx,vp_obeny),point(vp_rechtsx,vp_obeny),vp_depth);
        sirping(point(vp_linksx,vp_unteny),point(vp_rechtsx,vp_unteny),vp_depth);
      end;
  end;

  procedure piano(vp_links,vp_rechts:tpoint;vp_Depth:integer);
  var
    vp_length,vp_linksx,vp_rechtsx,vp_obeny,vp_unteny: integer;
  begin
    if (vp_depth>=sb_depth.Position)or(v_abbruch)
    then // Fertig
        with i.picture.Bitmap.Canvas
        do
          begin
            moveto(vp_links.x,vp_links.y);
            lineto(vp_rechts.x,vp_rechts.y);
          end
    else
      begin
        inc(vp_Depth);
        application.processmessages;
        vp_length:=((vp_rechts.x-vp_links.x) div 3);
        vp_linksx:=vp_links.x+vp_length;
        vp_rechtsx:=vp_linksx+vp_length;
        vp_obeny:=vp_links.y-vp_length;
        vp_unteny:=vp_links.y+vp_length;
        with i.Picture.Bitmap.Canvas
        do
          begin
            moveto(vp_linksx,vp_obeny);
            lineto(vp_linksx,vp_unteny);
            moveto(vp_rechtsx,vp_obeny);
            lineto(vp_rechtsx,vp_unteny);
            moveto(vp_links.x,vp_links.y);
            lineto(vp_rechts.x,vp_rechts.y);
          end;
        piano(vp_links,point(vp_linksx,vp_links.y),vp_depth);
        piano(point(vp_rechtsx,vp_links.y),vp_rechts,vp_depth);
        piano(point(vp_linksx,vp_obeny),point(vp_rechtsx,vp_obeny),vp_depth);
        piano(point(vp_linksx,vp_unteny),point(vp_rechtsx,vp_unteny),vp_depth);
      end;
  end;

begin
  v_abbruch:=false;
  // Bitmap erzeugen
  i.Picture.Bitmap.Create;
  i.Picture.Bitmap.Width:=i.Width;
  i.Picture.Bitmap.Height:=i.Height;
  i.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
  i.Picture.Bitmap.Canvas.fillrect(rect(0,0,i.width,i.height));
  i.Picture.Bitmap.Canvas.Pen.Color:=clblack;

  // kochkurve beginnen
  if rb_koch.checked then koch(point(10,i.height-10),point(i.width-20,i.height-10),0);

  // Sirpingsky beginnen
  if rb_sirping.checked then sirping(point(150,i.height div 2),point(i.width-150,i.height div 2),0);

  // Piano beginnen
  if rb_piano.checked then piano(point(150,i.height div 2),point(i.width-150,i.height div 2),0);

end;

procedure TForm1.b_abbruchClick(Sender: TObject);
begin
  v_abbruch:=true;
end;

procedure TForm1.sb_depthChange(Sender: TObject);
begin
  l_depth.Caption:='Rekursionstiefe: '+inttostr(sb_depth.Position);
end;

procedure TForm1.b_endeClick(Sender: TObject);
begin
  close;
end;

end.
